#!groovy

stage('linux test') {
    node('docker') {
        checkout scm

        def dockerRepository = "${env.JOB_NAME}".toLowerCase()
        def dockerTag = "${dockerRepository}:${env.BUILD_NUMBER}"
        def dockerContainerName = "${dockerRepository}_${env.BUILD_NUMBER}"

        sh """docker build \
            -t ${dockerTag} \
            ."""

        sh """docker run \
            -e BUILD_NUMBER=${env.BUILD_NUMBER} \
            -e DROPBOX_ACCESS_TOKEN=${env.DROPBOX_ACCESS_TOKEN} \
            --name ${dockerContainerName} \
            ${dockerTag}"""

        sh "docker cp ${dockerContainerName}:/artifacts ${env.WORKSPACE}"
        sh "docker stop ${dockerContainerName}"

        step([$class: 'JUnitResultArchiver', testResults: 'artifacts/**/*.xml'])
        //step([$class: 'RcovPublisher', reportDir: 'artifacts/coverage/rcov/'])
    }
}

stage('osx test') {
    node('ruby-osx') {
        checkout scm

        sh "bundle config specific_platform true"

        sh "bundle install --path='./gems/'"

        sh """DROPBOX_ACCESS_TOKEN=${env.DROPBOX_ACCESS_TOKEN} \
            RUBYOPT='-W0' \
            CI_CAPTURE=off \
            bundle exec \
            rake ci:setup:testunit \
            test:all \
            build"""

        step([$class: 'JUnitResultArchiver', testResults: 'test/reports/**/*.xml'])
    }
}

stage('windows test') {
    node('ruby-windows') {
        checkout scm

        bat 'call bundle config specific_platform true'
        bat 'call bundle install --path=./gems'
        bat 'set DROPBOX_ACCESS_TOKEN=${env.DROPBOX_ACCESS_TOKEN}'
        bat 'call bundle exec rake SSL_CERT_FILE=%cd%\\certs\\cacert.pem ci:setup:testunit test:default build'

        step([$class: 'JUnitResultArchiver', testResults: 'test/reports/**/*.xml'])
        //step([$class: 'RcovPublisher', reportDir: 'coverage/rcov/'])
    }
}
