require 'logger'

module LoggerUtil
  @logger ||= Logger.new(STDOUT)

  def self.log
    @logger
  end

  def self.fatal(message)
    @logger.fatal(message)
    abort
  end

  def self.verbose?(should_be_verbose)
    @logger.level = if should_be_verbose
                      Logger::DEBUG
                    else
                      Logger::INFO
                    end
  end
end
