require 'sys/proctable'
require 'jenkins_util/logger_util'

module ProcessUtil
  include Sys

  def self.kill_all_processes(name)
    ProcTable.ps do |process|
      if process.comm.to_s == name.to_s
        begin
          Process.kill('HUP', process.pid)
        rescue Errno::ESRCH
          LoggerUtil.log.debug("Killed process #{process.comm}")
        end
      end
    end
  end
end
